/****************************************************************************
* Copyright (C)2002 Lucent Technologies                                     *
* (clarkson@research.bell-labs.com http://cm.bell-labs.com/who/clarkson)    *
*                                                                           *
* This program is free software; you can redistribute it and/or             *
* modify it under the terms of the GNU General Public License               *
* as published by the Free Software Foundation; either                      *
* version 2 of the License, or (at your option) any later version.          *
*                                                                           *
* This program is distributed in the hope that it will be useful,           *
* but WITHOUT ANY WARRANTY; without even the implied warranty of            *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
* GNU General Public License for more details.                              *
*                                                                           *
* You should have received a copy of the GNU General Public License         *
* along with this program; if not, write to the Free Software               *
* Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA,                 *
* or visit http://www.gnu.org/licenses/gpl.html                             *
*****************************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <stdarg.h>

#include "my_rand.h"
#include "gen_dist.h"
#include "sb.h"
#include "Msbi.h"
#include "MMM.h"
#include "do_test.h"


main(int argc, char* argv[]) {

	sbp sbt;
	size_t nt; 
	int num_P = get_data(stdin);

	char packing = 1;
	size_t	L=5, K=1000; 
	float end_frac=0.1, gamma=1.2;

	switch (argc) {
		case 6: packing = atoi(argv[5]);
		case 5: gamma = atof(argv[4]);
		case 4: K = atoi(argv[3]);
		case 3:	L = atoi(argv[2]);
		case 2:	end_frac= atof(argv[1]); /* intentional fallthru */
	}
	fprintf(stderr, "got data\n"); fflush(stderr);

	init_my_rand();

	if (num_P/L < 500) nt = num_P/L; else nt = 500;

	make_shuffle(num_P, num_P-nt, num_P);

	dcounts[prep] = 0;
	if (1) sbt = build_Mp(my_dist, num_P/L, num_P-nt, K, gamma, end_frac, 0, packing);
	if (0) sbt = build_Mp_simple(my_dist, num_P/L, num_P-nt, K, gamma, end_frac, 0, packing);	
	
	print_prep(sbt);


	
	
	
	printf("%d	", num_P/L);
	test_sbt(sbt, num_P/L, num_P-nt, nt, 0, 0, search_M);

	free_data();

	free_sb_i(sbt, 0);

	return 0;

}
